#define __KERNEL__

#define off_t Xoff_t
#define u_char Xu_char
#define u_short Xu_short
#define u_int Xu_int
#define u_long Xu_long
#define u_quad_t Xu_quad_t
#define fsid_t Xfsid_t
#define loff_t Xloff_t
#define ino_t Xino_t
#define dev_t Xdev_t
#define gid_t Xgid_t
#define mode_t Xmode_t
#define nlink_t Xnlink_t
#define uid_t Xuid_t
#define pid_t Xpid_t
#define ssize_t Xssize_t
#define daddr_t Xdaddr_t
#define caddr_t Xcaddr_t
#define key_t Xkey_t
#define time_t Xtime_t
#define ulong Xulong
#define ushort Xushort
#define uint Xuint
#define int8_t Xint8_t
#define int16_t Xint16_t
#define int32_t Xint32_t
#define int64_t Xint64_t
#define u_int8_t Xu_int8_t
#define u_int16_t Xu_int16_t
#define u_int32_t Xu_int32_t
#define u_int64_t Xu_int64_t
#define timespec Xtimespec
#define fd_set Xfd_set
#define flock Xflock

#include <linux/fs.h>
#ifdef KWARE_C
#include <asm/io.h>
#endif

#undef off_t
#undef u_char
#undef u_short
#undef u_int
#undef u_long
#undef u_quad_t
#undef fsid_t
#undef loff_t
#undef ino_t
#undef dev_t
#undef gid_t
#undef mode_t
#undef nlink_t
#undef uid_t
#undef pid_t
#undef ssize_t
#undef daddr_t
#undef caddr_t
#undef key_t
#undef time_t
#undef ulong
#undef ushort
#undef uint
#undef int8_t
#undef int16_t
#undef int32_t
#undef int64_t
#undef u_int8_t
#undef u_int16_t
#undef u_int32_t
#undef u_int64_t
#undef timespec
#undef fd_set
#undef flock


#undef __FD_ZERO
#undef __FD_SET
#undef __FD_CLR
#undef __FD_ISSET
#undef FD_ZERO
#undef FD_SET
#undef FD_CLR
#undef FD_ISSET
#undef __NFDBITS
#undef __FDMASK
#undef __BIT_TYPES_DEFINED__
#undef asmlinkage
#undef FASYNC

#define asmlinkage

extern struct file_operations *module_fops;
extern struct file             module_file;
extern struct inode            module_inode;

#define prepuser() current->addr_limit.seg=0xFFFFFFFF

#ifndef KWARE_C

#define open  kware_open
#define read  kware_read
#define write kware_write
#define ioctl kware_ioctl

#endif
